<template>
  <div class="manual-tariff">
    <ob-radio
      label="Назначить тариф"
      v-model="tariff"
      valueInput="tariffByHand"
      name="tariff"
      data-qa="setTariffByHand"
      @change="$emit('tariffChanged', tariff)"
    />
    <div class="fetched-contracts" v-if="fetchedContracts.length">
      <contracts
        v-if="tariff === 'tariffByHand'"
        :fetchedContracts="fetchedContracts"
        @contractChanged="$emit('contractChanged', $event)"
      />
    </div>
    <div
      class="manual-tariff__value"
      v-if="tariff === 'tariffByHand'"
    >
      <ob-checkbox
        v-if="manualTariffVat > 0"
        label="С учётом НДС"
        v-model="includeVat"
        @change="$emit('updateTariffByHand', finalTariffByHand)"
      />
      <ob-input
        ref="tariffByHandInput"
        v-model="tariffByHandValue"
        :label="tariffByHandLabel"
        subTitle="руб"
        type="money:2"
        data-qa="tariffByHandValue"
        @focus="onHandTariffFocus"
        @input="$emit('updateTariffByHand', finalTariffByHand)"
      />
      <p
        v-if="
          manualTariffVat && manualTariffVat !== 0
        "
        class="manual-tariff__tax"
      >
        НДС:
        {{ manualTariffTax | currency({ dot: 2 }) }} ₽
      </p>
      <p
        v-if="
          (!manualTariffVat || manualTariffVat === 0)
        "
        class="manual-tariff__tax"
      >
        НДС не облагается
      </p>
    </div>
  </div>
</template>

<script>
import { formatNumber } from "common-components/src/helpers/common";
import contracts from "./fetchedContracts";
import obRadio from "common-components/src/obComponents/obRadio";
import obInput from "common-components/src/obComponents/obInput";
import obCheckbox from 'common-components/src/obComponents/obCheckbox';
export default {
  name: "draftManualTariff",

  props: {
    manualTariffVat: {
      type: [String, Number],
      default: 0,
    },

    shouldBeChecked: {
      type: Boolean,
    },

    fetchedContracts: {
      type: Array,
      default: () => []
    }
  },

  components: {
    contracts,
    obRadio,
    obInput,
    obCheckbox
  },

  watch: {
    shouldBeChecked: {
      handler: async function (newVal) {
        if (newVal) {
          this.tariffByHandValue = '';
          this.tariff = "tariffByHand";
        } else {
          this.tariff = null;
        }
      },
      immediate: true,
    },
  },

  data() {
    return {
      tariff: null,
      tariffByHandValue: "",
      includeVat: false,
    };
  },

  computed: {
    tariffByHandLabel() {
      return `Тариф ${this.includeVat ? 'с' : 'без'} НДС`;
    },
    finalTariffByHand() {
      if (this.tariffByHandValue.length) {
        const vat = this.includeVat
          ? this.tariffByHandValue / 100 -
            (this.tariffByHandValue / 100) *
              (100 / (100 + this.manualTariffVat)) +
            ""
          : 0;
        return this.tariffByHandValue - (vat * 100).toFixed() + "";
      }
      return '';
    },

    manualTariffTax() {
      return this.includeVat
        ? this.tariffByHandValue / 100 -
            (this.tariffByHandValue / 100) *
              (100 / (100 + this.manualTariffVat))
        : ((this.tariffByHandValue / 100) * this.manualTariffVat) / 100;
    },
  },

  methods: {
    formatNumber,

    onHandTariffFocus() {
      this.tariff = "tariffByHand";
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import "~common-components/src/static/css/variables";

.fetched-contracts {
  padding-left: 24px;
  padding-top: 17px;
}

.manual-tariff__value {
  margin-top: 10px;

  .ob-input-container {
    margin-top: 14px;
  }
}

.manual-tariff__tax {
  margin-top: 10px;
  font-size: 12px;
  line-height: 12px;
  letter-spacing: .4px;
  color: $gray-slate;
}
</style>